$include "rapidq.inc"
$include "fmod3.70.inc"
'-----------------
dim f$ as string
dim lngStream as long
    lngStream = FSOUND_Stream_Open (wave$, FSOUND_2D, 0,0)
dim lngChannel as long
DIM OpenDialog AS QOPENDIALOG 
OpenDialog.Filter = "Fichiers audio|*.wav;*.mp3" 
OpenDialog.FilterIndex = 1
dim position as integer
dim posL as integer
dim vl as integer
dim vr as integer    

declare sub timerF
declare sub Quit
declare sub init
declare sub play
declare sub stop
declare sub openF
declare sub pause
declare sub openF

Application.ShowHint = 1
Application.HintColor = &hb5ff00

dim font as QFont
Font.Name = "Arial" 
Font.AddStyles(fsBold, fsItalic)
font.Color = clBlue
font.size = 9

dim timer1 as QTimer
timer1.OnTimer = timerF
    timer1.enabled = 0
    timer1.interval = 10 
  
CREATE Form AS QForm
    Width = 550
    Height = 220
    caption = "GG_Player"
    color = 0
    Center
    create infoLabel as QLabel
        top = 20
        left = 35
        width = 50
        transparent = 1
        font = font
    end create
    create info2Label as QLabel
        top = 60
        left = 35
        width = 100
        transparent = 1
        font = font
    end create
        create info3Label as QLabel
        top = 140
        left = 35
        width = 100
        transparent = 1
        font = font
    end create
    CREATE PlayB AS QBUTTON
        Cursor = crHandPoint
        Left = 60
        Top = 100
        Height = 30
        Width = 30
        OnClick = play
        caption = ">"
        enabled = 0
        ShowHint = 1
        hint = "Lecture"
    END CREATE
    CREATE StopB AS QBUTTON
        Cursor = crHandPoint
        Left = 120        
        Top = 100
        Height = 30
        Width = 30
        OnClick = stop
        caption = "O"        
        enabled = 0
        ShowHint = 1
        hint = "Stop"
    END CREATE   
    CREATE openB AS QBUTTON
        Cursor = crHandPoint
        Left = 30
        Top = 100
        Height = 30
        Width = 30
        OnClick = openF
        caption = "^"
        ShowHint = 1
        Hint = "Ouvrir fichier"
    END CREATE
    CREATE PauseB AS QBUTTON
        Cursor = crHandPoint
        Left = 90
        Top = 100
        Height = 30
        Width = 30
        OnClick = pause
        caption = "="
        ShowHint = 1
        hint = "Pause"
        enabled = 0
    END CREATE
    CREATE QuitB AS QBUTTON
        Cursor = crHandPoint
        Left = 150
        Top = 100
        Height = 30
        Width = 30
        OnClick = Quit
        caption = "[]=>"
        ShowHint = 1
        Hint = "Quitter"
    END CREATE
    CREATE POSGauge AS QGauge
        top = 150
        left = 30
        width = 150
        height = 12
        backColor = clBlue
        visible = 0
    END CREATE
END CREATE

Form.ShowModal

'==================================================
SUB Quit
    FSOUND_Close
    Application.Terminate
END SUB
'==================================================
sub init   
    FSOUND_Init(44100, 32, 0)
end sub
'==================================================
sub play
    if f$="" then openF
    timer1.enabled = 1
    lngStream = FSOUND_Stream_Open (f$, FSOUND_2D, 0,0)    
    channel = FSOUND_Stream_Play (FSOUND_FREE,lngStream)
    If lngStream = 0 Then
        info3Label.caption = str$(lngStream)+ FSOUND_GetErrorString(FSOUND_GetError)
    End If   
    stopB.enabled = 1 : pauseB.enabled = 1 
    infoLabel.caption = "en lecture"    
end sub
'==================================================
sub stop
    'if FSOUND_IsPlaying(channel) <> 0 then
        FSOUND_Stream_Stop(lngStream)
        FSOUND_Stream_Close(lngStream)
        infoLabel.caption = "stop"
        timer1.enabled = 0
    'else
        'exit sub
    'end if
end sub
'==================================================
SUB OpenF  
    stop
    form.repaint
    f$=""
    if OpenDialog.Execute then
        f$ = OpenDialog.FileName
        for i = len(f$) to 1 step -1
            a$ = mid$(f$,i,1)
            if a$ = "\" then exit for
            ff$ = ff$+a$  
        next
        file$ = reverse$(ff$)
        form.Caption = file$
    end if
    playB.enabled = 1
    posGauge.visible = 1
    init
    lngStream = FSOUND_Stream_Open (f$, FSOUND_2D, 0,0)
    posL = FSOUND_Stream_Getlength(lngStream)
    infoLabel.caption = str$(FSOUND_GetFrequency(4))+ "htz" + " / "+str$((posL/100)/60) 
end sub    
'==================================================
sub pause
    paused = FSOUND_GetPaused(channel)
    infoLabel.caption = "en pause"
    if paused = 0 then
        FSOUND_SetPaused(channel,1)
        timer1.enabled = 0
        infoLabel.caption = "en pause"
    else
        FSOUND_SetPaused(channel,0)
        timer1.enabled = 1
        infoLabel.caption = "en lecture"
    end if
end sub
'==================================================
sub timerF
    timer1.enabled = 1
    x = x+10
    FSOUND_GetCurrentLevels (lngChannel,vl,vr)
    'infoLabel.caption = "volume = "+right$(str$(int(vl/100000)),3)+"-"+right$(str$(int(vr/100000)),3)
    position = FSOUND_Stream_GetPosition(lngStream)
    PosGr = position/posL
    Time = FSOUND_Stream_GetTime(lngStream)  
    info2Label.caption = "Secondes : "+str$(int(Time/1000))'millisecondes
    posGauge.position = int(posGr*100)
    vuL=val(right$(str$(int(vl/100000)),3))/10
    vuR=val(right$(str$(int(vr/100000)),3))/10
    'form.circle(300+vuL,80+vuL,300-vuL,80-vuL,rgb(255-vul*3,vul*3,vul),rgb(255-vul*3,vul*3,vul)) 
    'form.circle(450+vuR,80+vuR,450-vuR,80-vuR,rgb(vuR*3,255-vuR*3,255-vuR),rgb(vuR*3,255-vuR*3,255-vuR)) 
    'if x > 60 then
    'form.fillrect(300+vuL,80+vuL,300-vuL,80-vuL,rgb(255-vul*3,vul*3,vul))
    'form.fillrect(450+vuR,80+vuR,450-vuR,80-vuR,rgb(vuR*3,255-vuR*3,255-vuR))
    
    form.line((x-20)+150+vuL*2,10,(550-vuL)-(x-20),(100+vuL*2),0)
    form.line((x-20)+250+vuR*2,10,(650-vuR)-(x-20),(100+vuR*2),0) 
    form.line((x-10)+150+vuL*2,10,(550-vuL)-(x-10),(100+vuL*2),0)
    form.line((x-10)+250+vuR*2,10,(650-vuR)-(x-10),(100+vuR*2),0)    
    form.line(x+150+vuL*2,10,(550-vuL)-x,(100+vuL*2),rgb(255-vul*3,vul*3,vul))
    form.line(x+250+vuR*2,10,(650-vuR)-x,(100+vuR*2),rgb(vuR*3,255-vuR*3,255-vuR))  
    'end if  
    if x = 300 then x = 0
end sub

